/* tslint:disable */
/* eslint-disable */
/**
 * FastAPI
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 0.1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import type { Configuration } from '../configuration';
import type { AxiosPromise, AxiosInstance, RawAxiosRequestConfig } from 'axios';
import globalAxios from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError, operationServerMap } from '../base';
// @ts-ignore
import { Configuration as OsdConfiguration } from '../models';
// @ts-ignore
import { HTTPValidationError } from '../models';
// @ts-ignore
import { PrjSBDLinkResponse } from '../models';
// @ts-ignore
import { ProjectInput } from '../models';
// @ts-ignore
import { SBDefinitionInput } from '../models';
// @ts-ignore
import { ValidationResponse } from '../models';
/**
 * ODTAPIApi - axios parameter creator
 * @export
 */
export const ODTAPIApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Get static configuration data used by the ODT UI that is sourced from the OSD.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        configurationGetSkaOsoServicesOsoApiV0OdtConfigurationGet: async (options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/oso/api/v0/odt/configuration`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Retrieves the Project with the given identifier from the underlying data store, if available
         * @summary Get Project by identifier
         * @param {string} identifier 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        prjsGetSkaOsoServicesOsoApiV0OdtPrjsIdentifierGet: async (identifier: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'identifier' is not null or undefined
            assertParamExists('prjsGetSkaOsoServicesOsoApiV0OdtPrjsIdentifierGet', 'identifier', identifier)
            const localVarPath = `/oso/api/v0/odt/prjs/{identifier}`
                .replace(`{${"identifier"}}`, encodeURIComponent(String(identifier)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Creates a new Project in the underlying data store. The response contains the entity as it exists in the data store, with a prj_id and metadata populated.
         * @summary Create a new Project
         * @param {ProjectInput} projectInput 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        prjsPostSkaOsoServicesOsoApiV0OdtPrjsPost: async (projectInput: ProjectInput, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'projectInput' is not null or undefined
            assertParamExists('prjsPostSkaOsoServicesOsoApiV0OdtPrjsPost', 'projectInput', projectInput)
            const localVarPath = `/oso/api/v0/odt/prjs/`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(projectInput, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Updates the Project with the given identifier in the underlying data store to create a new version.
         * @summary Update a Project by identifier
         * @param {string} identifier 
         * @param {ProjectInput} projectInput 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        prjsPutSkaOsoServicesOsoApiV0OdtPrjsIdentifierPut: async (identifier: string, projectInput: ProjectInput, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'identifier' is not null or undefined
            assertParamExists('prjsPutSkaOsoServicesOsoApiV0OdtPrjsIdentifierPut', 'identifier', identifier)
            // verify required parameter 'projectInput' is not null or undefined
            assertParamExists('prjsPutSkaOsoServicesOsoApiV0OdtPrjsIdentifierPut', 'projectInput', projectInput)
            const localVarPath = `/oso/api/v0/odt/prjs/{identifier}`
                .replace(`{${"identifier"}}`, encodeURIComponent(String(identifier)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(projectInput, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Creates an SBDefintiion linked to the given project. The response contains the entity as it exists in the data store, with an sbd_id and metadata populated.  If no request body is passed, a default \'empty\' SBDefinition will be created.
         * @summary Create a new SBDefinition linked to a project
         * @param {string} identifier 
         * @param {string} obsBlockId 
         * @param {SBDefinitionInput} sbDefinitionInput
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        prjsSbdsPostSkaOsoServicesOsoApiV0OdtPrjsIdentifierObsBlockIdSbdsPost: async (identifier: string, obsBlockId: string, sbDefinitionInput?: SBDefinitionInput, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'identifier' is not null or undefined
            assertParamExists('prjsSbdsPostSkaOsoServicesOsoApiV0OdtPrjsIdentifierObsBlockIdSbdsPost', 'identifier', identifier)
            // verify required parameter 'obsBlockId' is not null or undefined
            assertParamExists('prjsSbdsPostSkaOsoServicesOsoApiV0OdtPrjsIdentifierObsBlockIdSbdsPost', 'obsBlockId', obsBlockId)
            const localVarPath = `/oso/api/v0/odt/prjs/{identifier}/{obs_block_id}/sbds`
                .replace(`{${"identifier"}}`, encodeURIComponent(String(identifier)))
                .replace(`{${"obs_block_id"}}`, encodeURIComponent(String(obsBlockId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(sbDefinitionInput, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Returns a json SchedulingBlockDefinition with empty or generated fields, to be populated and stored at a later point
         * @summary Create empty SBD
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        sbdsCreateSkaOsoServicesOsoApiV0OdtSbdsCreateGet: async (options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/oso/api/v0/odt/sbds/create`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Retrieves the SchedulingBlockDefinition with the given identifier from the underlying data store, if available.
         * @summary Get SBD by identifier
         * @param {string} identifier 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        sbdsGetSkaOsoServicesOsoApiV0OdtSbdsIdentifierGet: async (identifier: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'identifier' is not null or undefined
            assertParamExists('sbdsGetSkaOsoServicesOsoApiV0OdtSbdsIdentifierGet', 'identifier', identifier)
            const localVarPath = `/oso/api/v0/odt/sbds/{identifier}`
                .replace(`{${"identifier"}}`, encodeURIComponent(String(identifier)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Creates a new SchedulingBlockDefinition in the underlying data store. The response contains the entity as it exists in the data store, with an sbd_id and metadata populated.
         * @summary Create a new SBDefinition
         * @param {SBDefinitionInput} sBDefinitionInput 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        sbdsPostSkaOsoServicesOsoApiV0OdtSbdsPost: async (sBDefinitionInput: SBDefinitionInput, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'sBDefinitionInput' is not null or undefined
            assertParamExists('sbdsPostSkaOsoServicesOsoApiV0OdtSbdsPost', 'sBDefinitionInput', sBDefinitionInput)
            const localVarPath = `/oso/api/v0/odt/sbds/`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(sBDefinitionInput, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Updates the SchedulingBlockDefinition with the given identifier in the underlying data store to create a new version.
         * @summary Update an SBDefinition by identifier
         * @param {string} identifier 
         * @param {SBDefinitionInput} sBDefinitionInput 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        sbdsPutSkaOsoServicesOsoApiV0OdtSbdsIdentifierPut: async (identifier: string, sBDefinitionInput: SBDefinitionInput, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'identifier' is not null or undefined
            assertParamExists('sbdsPutSkaOsoServicesOsoApiV0OdtSbdsIdentifierPut', 'identifier', identifier)
            // verify required parameter 'sBDefinitionInput' is not null or undefined
            assertParamExists('sbdsPutSkaOsoServicesOsoApiV0OdtSbdsIdentifierPut', 'sBDefinitionInput', sBDefinitionInput)
            const localVarPath = `/oso/api/v0/odt/sbds/{identifier}`
                .replace(`{${"identifier"}}`, encodeURIComponent(String(identifier)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(sBDefinitionInput, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Validates the SchedulingBlockDefinition in the request body against the component definition (eg required fields, allowed ranges) and more complex business logic in the controller method.
         * @summary Validate an SBD
         * @param {SBDefinitionInput} sBDefinitionInput 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        sbdsValidateSkaOsoServicesOsoApiV0OdtSbdsValidatePost: async (sBDefinitionInput: SBDefinitionInput, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'sBDefinitionInput' is not null or undefined
            assertParamExists('sbdsValidateSkaOsoServicesOsoApiV0OdtSbdsValidatePost', 'sBDefinitionInput', sBDefinitionInput)
            const localVarPath = `/oso/api/v0/odt/sbds/validate`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(sBDefinitionInput, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * ODTAPIApi - functional programming interface
 * @export
 */
export const ODTAPIApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = ODTAPIApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Get static configuration data used by the ODT UI that is sourced from the OSD.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async configurationGetSkaOsoServicesOsoApiV0OdtConfigurationGet(options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<OsdConfiguration>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.configurationGetSkaOsoServicesOsoApiV0OdtConfigurationGet(options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ODTAPIApi.configurationGetSkaOsoServicesOsoApiV0OdtConfigurationGet']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * Retrieves the Project with the given identifier from the underlying data store, if available
         * @summary Get Project by identifier
         * @param {string} identifier 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async prjsGetSkaOsoServicesOsoApiV0OdtPrjsIdentifierGet(identifier: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<object>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.prjsGetSkaOsoServicesOsoApiV0OdtPrjsIdentifierGet(identifier, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ODTAPIApi.prjsGetSkaOsoServicesOsoApiV0OdtPrjsIdentifierGet']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * Creates a new Project in the underlying data store. The response contains the entity as it exists in the data store, with a prj_id and metadata populated.
         * @summary Create a new Project
         * @param {ProjectInput} projectInput 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async prjsPostSkaOsoServicesOsoApiV0OdtPrjsPost(projectInput: ProjectInput, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<object>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.prjsPostSkaOsoServicesOsoApiV0OdtPrjsPost(projectInput, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ODTAPIApi.prjsPostSkaOsoServicesOsoApiV0OdtPrjsPost']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * Updates the Project with the given identifier in the underlying data store to create a new version.
         * @summary Update a Project by identifier
         * @param {string} identifier 
         * @param {ProjectInput} projectInput 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async prjsPutSkaOsoServicesOsoApiV0OdtPrjsIdentifierPut(identifier: string, projectInput: ProjectInput, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<object>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.prjsPutSkaOsoServicesOsoApiV0OdtPrjsIdentifierPut(identifier, projectInput, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ODTAPIApi.prjsPutSkaOsoServicesOsoApiV0OdtPrjsIdentifierPut']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * Creates an SBDefintiion linked to the given project. The response contains the entity as it exists in the data store, with an sbd_id and metadata populated.  If no request body is passed, a default \'empty\' SBDefinition will be created.
         * @summary Create a new SBDefinition linked to a project
         * @param {string} identifier 
         * @param {string} obsBlockId 
         * @param {SBDefinitionInput} sbDefinitionInput
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async prjsSbdsPostSkaOsoServicesOsoApiV0OdtPrjsIdentifierObsBlockIdSbdsPost(identifier: string, obsBlockId: string, sbDefinitionInput?: SBDefinitionInput, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PrjSBDLinkResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.prjsSbdsPostSkaOsoServicesOsoApiV0OdtPrjsIdentifierObsBlockIdSbdsPost(identifier, obsBlockId, sbDefinitionInput, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ODTAPIApi.prjsSbdsPostSkaOsoServicesOsoApiV0OdtPrjsIdentifierObsBlockIdSbdsPost']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * Returns a json SchedulingBlockDefinition with empty or generated fields, to be populated and stored at a later point
         * @summary Create empty SBD
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async sbdsCreateSkaOsoServicesOsoApiV0OdtSbdsCreateGet(options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<object>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.sbdsCreateSkaOsoServicesOsoApiV0OdtSbdsCreateGet(options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ODTAPIApi.sbdsCreateSkaOsoServicesOsoApiV0OdtSbdsCreateGet']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * Retrieves the SchedulingBlockDefinition with the given identifier from the underlying data store, if available.
         * @summary Get SBD by identifier
         * @param {string} identifier 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async sbdsGetSkaOsoServicesOsoApiV0OdtSbdsIdentifierGet(identifier: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<object>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.sbdsGetSkaOsoServicesOsoApiV0OdtSbdsIdentifierGet(identifier, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ODTAPIApi.sbdsGetSkaOsoServicesOsoApiV0OdtSbdsIdentifierGet']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * Creates a new SchedulingBlockDefinition in the underlying data store. The response contains the entity as it exists in the data store, with an sbd_id and metadata populated.
         * @summary Create a new SBDefinition
         * @param {SBDefinitionInput} sBDefinitionInput 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async sbdsPostSkaOsoServicesOsoApiV0OdtSbdsPost(sBDefinitionInput: SBDefinitionInput, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<object>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.sbdsPostSkaOsoServicesOsoApiV0OdtSbdsPost(sBDefinitionInput, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ODTAPIApi.sbdsPostSkaOsoServicesOsoApiV0OdtSbdsPost']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * Updates the SchedulingBlockDefinition with the given identifier in the underlying data store to create a new version.
         * @summary Update an SBDefinition by identifier
         * @param {string} identifier 
         * @param {SBDefinitionInput} sBDefinitionInput 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async sbdsPutSkaOsoServicesOsoApiV0OdtSbdsIdentifierPut(identifier: string, sBDefinitionInput: SBDefinitionInput, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<object>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.sbdsPutSkaOsoServicesOsoApiV0OdtSbdsIdentifierPut(identifier, sBDefinitionInput, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ODTAPIApi.sbdsPutSkaOsoServicesOsoApiV0OdtSbdsIdentifierPut']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * Validates the SchedulingBlockDefinition in the request body against the component definition (eg required fields, allowed ranges) and more complex business logic in the controller method.
         * @summary Validate an SBD
         * @param {SBDefinitionInput} sBDefinitionInput 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async sbdsValidateSkaOsoServicesOsoApiV0OdtSbdsValidatePost(sBDefinitionInput: SBDefinitionInput, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ValidationResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.sbdsValidateSkaOsoServicesOsoApiV0OdtSbdsValidatePost(sBDefinitionInput, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ODTAPIApi.sbdsValidateSkaOsoServicesOsoApiV0OdtSbdsValidatePost']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
    }
};

/**
 * ODTAPIApi - factory interface
 * @export
 */
export const ODTAPIApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = ODTAPIApiFp(configuration)
    return {
        /**
         * 
         * @summary Get static configuration data used by the ODT UI that is sourced from the OSD.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        configurationGetSkaOsoServicesOsoApiV0OdtConfigurationGet(options?: any): AxiosPromise<OsdConfiguration> {
            return localVarFp.configurationGetSkaOsoServicesOsoApiV0OdtConfigurationGet(options).then((request) => request(axios, basePath));
        },
        /**
         * Retrieves the Project with the given identifier from the underlying data store, if available
         * @summary Get Project by identifier
         * @param {string} identifier 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        prjsGetSkaOsoServicesOsoApiV0OdtPrjsIdentifierGet(identifier: string, options?: any): AxiosPromise<object> {
            return localVarFp.prjsGetSkaOsoServicesOsoApiV0OdtPrjsIdentifierGet(identifier, options).then((request) => request(axios, basePath));
        },
        /**
         * Creates a new Project in the underlying data store. The response contains the entity as it exists in the data store, with a prj_id and metadata populated.
         * @summary Create a new Project
         * @param {ProjectInput} projectInput 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        prjsPostSkaOsoServicesOsoApiV0OdtPrjsPost(projectInput: ProjectInput, options?: any): AxiosPromise<object> {
            return localVarFp.prjsPostSkaOsoServicesOsoApiV0OdtPrjsPost(projectInput, options).then((request) => request(axios, basePath));
        },
        /**
         * Updates the Project with the given identifier in the underlying data store to create a new version.
         * @summary Update a Project by identifier
         * @param {string} identifier 
         * @param {ProjectInput} projectInput 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        prjsPutSkaOsoServicesOsoApiV0OdtPrjsIdentifierPut(identifier: string, projectInput: ProjectInput, options?: any): AxiosPromise<object> {
            return localVarFp.prjsPutSkaOsoServicesOsoApiV0OdtPrjsIdentifierPut(identifier, projectInput, options).then((request) => request(axios, basePath));
        },
        /**
         * Creates an SBDefintiion linked to the given project. The response contains the entity as it exists in the data store, with an sbd_id and metadata populated.  If no request body is passed, a default \'empty\' SBDefinition will be created.
         * @summary Create a new SBDefinition linked to a project
         * @param {string} identifier 
         * @param {string} obsBlockId 
         * @param {SBDefinitionInput} sbDefinitionInput
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        prjsSbdsPostSkaOsoServicesOsoApiV0OdtPrjsIdentifierObsBlockIdSbdsPost(identifier: string, obsBlockId: string, sbDefinitionInput?: SBDefinitionInput, options?: any): AxiosPromise<PrjSBDLinkResponse> {
            return localVarFp.prjsSbdsPostSkaOsoServicesOsoApiV0OdtPrjsIdentifierObsBlockIdSbdsPost(identifier, obsBlockId, sbDefinitionInput, options).then((request) => request(axios, basePath));
        },
        /**
         * Returns a json SchedulingBlockDefinition with empty or generated fields, to be populated and stored at a later point
         * @summary Create empty SBD
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        sbdsCreateSkaOsoServicesOsoApiV0OdtSbdsCreateGet(options?: any): AxiosPromise<object> {
            return localVarFp.sbdsCreateSkaOsoServicesOsoApiV0OdtSbdsCreateGet(options).then((request) => request(axios, basePath));
        },
        /**
         * Retrieves the SchedulingBlockDefinition with the given identifier from the underlying data store, if available.
         * @summary Get SBD by identifier
         * @param {string} identifier 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        sbdsGetSkaOsoServicesOsoApiV0OdtSbdsIdentifierGet(identifier: string, options?: any): AxiosPromise<object> {
            return localVarFp.sbdsGetSkaOsoServicesOsoApiV0OdtSbdsIdentifierGet(identifier, options).then((request) => request(axios, basePath));
        },
        /**
         * Creates a new SchedulingBlockDefinition in the underlying data store. The response contains the entity as it exists in the data store, with an sbd_id and metadata populated.
         * @summary Create a new SBDefinition
         * @param {SBDefinitionInput} sBDefinitionInput 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        sbdsPostSkaOsoServicesOsoApiV0OdtSbdsPost(sBDefinitionInput: SBDefinitionInput, options?: any): AxiosPromise<object> {
            return localVarFp.sbdsPostSkaOsoServicesOsoApiV0OdtSbdsPost(sBDefinitionInput, options).then((request) => request(axios, basePath));
        },
        /**
         * Updates the SchedulingBlockDefinition with the given identifier in the underlying data store to create a new version.
         * @summary Update an SBDefinition by identifier
         * @param {string} identifier 
         * @param {SBDefinitionInput} sBDefinitionInput 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        sbdsPutSkaOsoServicesOsoApiV0OdtSbdsIdentifierPut(identifier: string, sBDefinitionInput: SBDefinitionInput, options?: any): AxiosPromise<object> {
            return localVarFp.sbdsPutSkaOsoServicesOsoApiV0OdtSbdsIdentifierPut(identifier, sBDefinitionInput, options).then((request) => request(axios, basePath));
        },
        /**
         * Validates the SchedulingBlockDefinition in the request body against the component definition (eg required fields, allowed ranges) and more complex business logic in the controller method.
         * @summary Validate an SBD
         * @param {SBDefinitionInput} sBDefinitionInput 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        sbdsValidateSkaOsoServicesOsoApiV0OdtSbdsValidatePost(sBDefinitionInput: SBDefinitionInput, options?: any): AxiosPromise<ValidationResponse> {
            return localVarFp.sbdsValidateSkaOsoServicesOsoApiV0OdtSbdsValidatePost(sBDefinitionInput, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * ODTAPIApi - object-oriented interface
 * @export
 * @class ODTAPIApi
 * @extends {BaseAPI}
 */
export class ODTAPIApi extends BaseAPI {
    /**
     * 
     * @summary Get static configuration data used by the ODT UI that is sourced from the OSD.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ODTAPIApi
     */
    public configurationGetSkaOsoServicesOsoApiV0OdtConfigurationGet(options?: RawAxiosRequestConfig) {
        return ODTAPIApiFp(this.configuration).configurationGetSkaOsoServicesOsoApiV0OdtConfigurationGet(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * Retrieves the Project with the given identifier from the underlying data store, if available
     * @summary Get Project by identifier
     * @param {string} identifier 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ODTAPIApi
     */
    public prjsGetSkaOsoServicesOsoApiV0OdtPrjsIdentifierGet(identifier: string, options?: RawAxiosRequestConfig) {
        return ODTAPIApiFp(this.configuration).prjsGetSkaOsoServicesOsoApiV0OdtPrjsIdentifierGet(identifier, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * Creates a new Project in the underlying data store. The response contains the entity as it exists in the data store, with a prj_id and metadata populated.
     * @summary Create a new Project
     * @param {ProjectInput} projectInput 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ODTAPIApi
     */
    public prjsPostSkaOsoServicesOsoApiV0OdtPrjsPost(projectInput: ProjectInput, options?: RawAxiosRequestConfig) {
        return ODTAPIApiFp(this.configuration).prjsPostSkaOsoServicesOsoApiV0OdtPrjsPost(projectInput, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * Updates the Project with the given identifier in the underlying data store to create a new version.
     * @summary Update a Project by identifier
     * @param {string} identifier 
     * @param {ProjectInput} projectInput 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ODTAPIApi
     */
    public prjsPutSkaOsoServicesOsoApiV0OdtPrjsIdentifierPut(identifier: string, projectInput: ProjectInput, options?: RawAxiosRequestConfig) {
        return ODTAPIApiFp(this.configuration).prjsPutSkaOsoServicesOsoApiV0OdtPrjsIdentifierPut(identifier, projectInput, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * Creates an SBDefintiion linked to the given project. The response contains the entity as it exists in the data store, with an sbd_id and metadata populated.  If no request body is passed, a default \'empty\' SBDefinition will be created.
     * @summary Create a new SBDefinition linked to a project
     * @param {string} identifier 
     * @param {string} obsBlockId 
     * @param {SBDefinitionInput} sbDefinitionInput
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ODTAPIApi
     */
    public prjsSbdsPostSkaOsoServicesOsoApiV0OdtPrjsIdentifierObsBlockIdSbdsPost(identifier: string, obsBlockId: string, sbDefinitionInput?: SBDefinitionInput, options?: RawAxiosRequestConfig) {
        return ODTAPIApiFp(this.configuration).prjsSbdsPostSkaOsoServicesOsoApiV0OdtPrjsIdentifierObsBlockIdSbdsPost(identifier, obsBlockId, sbDefinitionInput, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * Returns a json SchedulingBlockDefinition with empty or generated fields, to be populated and stored at a later point
     * @summary Create empty SBD
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ODTAPIApi
     */
    public sbdsCreateSkaOsoServicesOsoApiV0OdtSbdsCreateGet(options?: RawAxiosRequestConfig) {
        return ODTAPIApiFp(this.configuration).sbdsCreateSkaOsoServicesOsoApiV0OdtSbdsCreateGet(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * Retrieves the SchedulingBlockDefinition with the given identifier from the underlying data store, if available.
     * @summary Get SBD by identifier
     * @param {string} identifier 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ODTAPIApi
     */
    public sbdsGetSkaOsoServicesOsoApiV0OdtSbdsIdentifierGet(identifier: string, options?: RawAxiosRequestConfig) {
        return ODTAPIApiFp(this.configuration).sbdsGetSkaOsoServicesOsoApiV0OdtSbdsIdentifierGet(identifier, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * Creates a new SchedulingBlockDefinition in the underlying data store. The response contains the entity as it exists in the data store, with an sbd_id and metadata populated.
     * @summary Create a new SBDefinition
     * @param {SBDefinitionInput} sBDefinitionInput 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ODTAPIApi
     */
    public sbdsPostSkaOsoServicesOsoApiV0OdtSbdsPost(sBDefinitionInput: SBDefinitionInput, options?: RawAxiosRequestConfig) {
        return ODTAPIApiFp(this.configuration).sbdsPostSkaOsoServicesOsoApiV0OdtSbdsPost(sBDefinitionInput, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * Updates the SchedulingBlockDefinition with the given identifier in the underlying data store to create a new version.
     * @summary Update an SBDefinition by identifier
     * @param {string} identifier 
     * @param {SBDefinitionInput} sBDefinitionInput 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ODTAPIApi
     */
    public sbdsPutSkaOsoServicesOsoApiV0OdtSbdsIdentifierPut(identifier: string, sBDefinitionInput: SBDefinitionInput, options?: RawAxiosRequestConfig) {
        return ODTAPIApiFp(this.configuration).sbdsPutSkaOsoServicesOsoApiV0OdtSbdsIdentifierPut(identifier, sBDefinitionInput, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * Validates the SchedulingBlockDefinition in the request body against the component definition (eg required fields, allowed ranges) and more complex business logic in the controller method.
     * @summary Validate an SBD
     * @param {SBDefinitionInput} sBDefinitionInput 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ODTAPIApi
     */
    public sbdsValidateSkaOsoServicesOsoApiV0OdtSbdsValidatePost(sBDefinitionInput: SBDefinitionInput, options?: RawAxiosRequestConfig) {
        return ODTAPIApiFp(this.configuration).sbdsValidateSkaOsoServicesOsoApiV0OdtSbdsValidatePost(sBDefinitionInput, options).then((request) => request(this.axios, this.basePath));
    }
}

